#pragma once

#include <stddef.h>
#define ARR_SZ(a) (sizeof(a) / sizeof(*(a)))
#define LSB(n) (n & 0xff)
#define MSB(n) ((n >> 8) & 0xff)

/* Macro used to read a struct field from program memory (supported field
 * sizes: 1, 2 and 4 bytes) */
#define get_pgm_struct_field(addr, field) ( \
	(sizeof(((typeof(*(addr))*)0)->field) == 1) ? \
		pgm_read_byte((uint8_t*)(addr) + offsetof(typeof(*(addr)), field)) \
	: (sizeof(((typeof(*(addr))*)0)->field)== 2) ? \
		pgm_read_word((uint8_t*)(addr) + offsetof(typeof(*(addr)), field)) \
	: \
		pgm_read_dword((uint8_t*)(addr) + offsetof(typeof(*(addr)), field)) \
	)

/* evaluates to ceil(x / n) */
#define divceil(x, n) (((x) + (n) - 1) / (n))
#define min(x, y) ((x) < (y) ? (x) : (y))

// Missing in power.h for the ATmegaXU2 (WinAVR 20100110)

#if defined(__AVR_ATmega16U2__)

 #if ! defined(clock_prescale_set)

typedef enum
    {
        clock_div_1   = 0, clock_div_2   = 1,
        clock_div_4   = 2, clock_div_8   = 3,
        clock_div_16  = 4, clock_div_32  = 5,
        clock_div_64  = 6, clock_div_128 = 7,
        clock_div_256 = 8
    }
    clock_div_t ;

#define clock_prescale_set( x )                 \
        do {                                    \
                uint8_t tmp = _BV(CLKPCE) ;     \
                __asm__ __volatile__ (          \
                "in __tmp_reg__,__SREG__" "\n\t"\
                "cli" "\n\t"                    \
                "sts %1, %0" "\n\t"             \
                "sts %1, %2" "\n\t"             \
                "out __SREG__, __tmp_reg__"     \
                : /* no outputs */              \
                : "d" (tmp),                    \
                  "M" (_SFR_MEM_ADDR(CLKPR)),   \
                  "d" (x)                       \
                : "r0" ) ;                      \
        } while (0)

#define clock_prescale_get()                    \
        (clock_div_t)(CLKPR & (uint8_t)         \
        ((1<<CLKPS0) | (1<<CLKPS1) |            \
         (1<<CLKPS2) | (1<<CLKPS3)) )
 #endif
#endif

